Description

Currently, it is not possible to link to an anchor of the current wiki page without having to also mention the name of the current wiki

page in the link. This becomes tedious quickly if there are many such links. Should the wiki page later be moved, these inline links

become quickly obsolete.

The attached patch which we developed for one of our customers at Planio adds the possibility to link directly to an anchor using the

following syntax:

simple link: [[#Anchor]]

link with custom text: [[#Anchor|Link Text]]

Related issues:

Related to Redmine - Feature #17455: Easier anchor linking / Textile anchor l... New

Related to Redmine - Patch #28998: Japanese wiki help translation update (r17... Closed

Related to Redmine - Defect #12981: Wiki self-link with anchor looks strange ... Closed

Has duplicate Redmine - Feature #18043: Links to anchors inside the page shou... Closed

Associated revisions

Revision 17345 - 2018-05-21 01:52 - Go MAEDA

Allow to link to an anchor of the current wiki page (#16313).

Patch by Holger Just.

Revision 17346 - 2018-05-21 01:56 - Go MAEDA

Add test for r17345 (#16313).

Patch by Go MAEDA.

Revision 17367 - 2018-06-06 06:07 - Go MAEDA

Updates wiki help: Link to an anchor of the current wikipage (#16313).

Patch by Go MAEDA.

History

#1 - 2017-11-21 06:25 - Go MAEDA

- Target version set to 4.1.0

I think the proposed behavior is more natural than the current behavior. Setting target version to 4.1.0.

#2 - 2018-01-08 05:16 - Go MAEDA

- File 16313-test.diff added

Tests for this feature.

#3 - 2018-01-10 08:00 - Go MAEDA

- File 16313-confusing-link@2x.png added

I found that the patch generates a confusing link in some cases. If an anchor consists of only numeric characters, the generated link looks like an

issue.
#4 - 2018-04-01 02:17 - Go MAEDA

- Related to Feature #17455: Easier anchor linking / Textile anchor links added

#5 - 2018-04-01 02:26 - Go MAEDA

Go MAEDA wrote:

I found that the patch generates a confusing link in some cases. If an anchor consists of only numeric characters, the generated link looks like an

issue.

 Does anyone have any comments on this behavior? I think this is acceptable because people rarely create wiki pages with such names.

#6 - 2018-05-20 04:50 - Go MAEDA

- Subject changed from Allow to link to an achor of the current wikipage to Allow to link to an anchor of the current wikipage

- Assignee set to Go MAEDA

#7 - 2018-05-21 02:01 - Go MAEDA

- Status changed from New to Closed

- Target version changed from 4.1.0 to 4.0.0

Committed. Thank you for sharing the patch.

#8 - 2018-05-21 02:28 - Go MAEDA

- Status changed from Closed to Reopened

It would be better to update documents as well. I will make a patch to update documents for all languages.

Index: public/help/en/wiki_syntax_detailed_markdown.html

===================================================================

--- public/help/en/wiki_syntax_detailed_markdown.html    (revision 17345)

+++ public/help/en/wiki_syntax_detailed_markdown.html    (working copy)

@@ -24,6 +24,7 @@

         <ul>

             <li><strong>[[Guide]]</strong> displays a link to the page named 'Guide': <a href="#" class="wiki

-page">Guide</a></li>

             <li><strong>[[Guide#further-reading]]</strong> takes you to the anchor "further-reading". Heading

s get automatically assigned anchors so that you can refer to them: <a href="#" class="wiki-page">Guide</a></l

i>

+            <li><strong>[[#further-reading]]</strong> link to the anchor "further-reading" of the current pag

e: <a href="#" class="wiki-page">#further-reading</a></li>

             <li><strong>[[Guide|User manual]]</strong> displays a link to the same page but with a different 

text: <a href="#" class="wiki-page">User manual</a></li>

         </ul>

Index: public/help/en/wiki_syntax_detailed_textile.html

2025-05-17 2/3



===================================================================

--- public/help/en/wiki_syntax_detailed_textile.html    (revision 17345)

+++ public/help/en/wiki_syntax_detailed_textile.html    (working copy)

@@ -24,6 +24,7 @@

         <ul>

             <li><strong>[[Guide]]</strong> displays a link to the page named 'Guide': <a href="#" class="wiki

-page">Guide</a></li>

             <li><strong>[[Guide#further-reading]]</strong> takes you to the anchor "further-reading". Heading

s get automatically assigned anchors so that you can refer to them: <a href="#" class="wiki-page">Guide</a></l

i>

+            <li><strong>[[#further-reading]]</strong> link to the anchor "further-reading" of the current pag

e: <a href="#" class="wiki-page">#further-reading</a></li>

             <li><strong>[[Guide|User manual]]</strong> displays a link to the same page but with a different 

text: <a href="#" class="wiki-page">User manual</a></li>

         </ul>

#9 - 2018-05-30 11:10 - Enziin System

Please push to Github.

Thanks.

#10 - 2018-06-03 11:45 - Go MAEDA

- File 16313-update-help.diff added

Here is a patch for "Wiki formatting" documents.

#11 - 2018-06-05 06:22 - Go MAEDA

- File 16313-update-help-v2.diff added

Updated the patch for help files. I hadn't updated wiki_syntax_detailed_textile.html for fr, ru and zh.

#12 - 2018-06-06 06:07 - Go MAEDA

- Status changed from Reopened to Closed

Updated wiki help.

#13 - 2018-06-11 02:26 - Go MAEDA

- Related to Patch #28998: Japanese wiki help translation update (r17367) added

#14 - 2019-10-01 05:49 - Go MAEDA

- Has duplicate Feature #18043: Links to anchors inside the page should be pagename-independent added

#15 - 2021-06-12 10:38 - Go MAEDA

- Related to Defect #12981: Wiki self-link with anchor looks strange in "preview" section. added

Files

wiki_anchors.diff 728 Bytes 2014-03-11 Holger Just

16313-test.diff 792 Bytes 2018-01-08 Go MAEDA

16313-confusing-link@2x.png 27.4 KB 2018-01-10 Go MAEDA

16313-update-help.diff 94.3 KB 2018-06-03 Go MAEDA

16313-update-help-v2.diff 97.6 KB 2018-06-05 Go MAEDA
